SUBROUTINE ATMOSP
!
!  ATMOSP propagates the solution of the equations
!
!  d(U)/dt = - (1/RHO0)*d(Patm)/dx
!
!  d(V)/dt = - (1/RHO0)*d(Patm)/dy
!
!  where Patm is the atmospheric pressure
!
USE MOD_MAIN
IMPLICIT NONE
REAL XFACT,YFACT
!
XFACT = DT/(DX*RHO0)
YFACT = DT/(DY*RHO0)
DO J = 2,JM
  DO I = 2,IM
    IF (DUM(I,J).GT.0.) THEN
      DO K = 1,KB-1
        U(I,J,K) = U(I,J,K) - XFACT*(PATM(I,J)-PATM(I-1,J))
      END DO
    ENDIF
    IF (DVM(I,J).GT.0.) THEN
      DO K = 1,KB-1
        V(I,J,K) = V(I,J,K) - YFACT*(PATM(I,J)-PATM(I,J-1))
      END DO
    ENDIF
  END DO
END DO
!
!  Estimate a water level that balances the atmospheric pressure.
!
ETABFRS = -(PATM-PMEAN)/(RHO0*GRAV)
!
RETURN
END
