! This routine sets up the logical arrays used to manually do
! gather-scatter optimization; counts the number of sea points, and
! generates array indices to access sea points. now looping over wet
! points can be done without if-statements inside the loop
!
!DO pt=1,numup
!   i=indu(1,pt)
!   j=indu(2,pt)
!
!   blablalba...
!
!END DO
!
! Now we can automatically parallelize the pt loop, and get automatic
! load balancing w.r. floating point ops. without any more tricks.
! The downside is the placement of stuff in memory. 
!
! Helge Avlesen <avle@ii.uib.no>

SUBROUTINE condition
  USE state

  numup=0
  numvp=0
  numcp=0
  numcp2=0

  DO j = 2,jm-1  
     DO i = 2,im  
        IF (dum(i,j).NE.0.) THEN
           numup=numup+1
           indu(1,numup)=i
           indu(2,numup)=j           
        END IF
     END DO
  END DO

  DO j = 2,jm  
     DO i = 2,im-1  
        IF (dvm(i,j).NE.0.) THEN
           numvp=numvp+1
           indv(1,numvp)=i
           indv(2,numvp)=j           
        END IF
     END DO
  END DO

  DO j = 2,jm-1  
     DO i = 2,im-1          
        IF (fsm(i,j).NE.0.) THEN
           numcp=numcp+1
           indc(1,numcp)=i
           indc(2,numcp)=j           
        END IF
     END DO
  END DO

! loop ranges for my2halv  
  DO j = 1,jm-1  
     DO i = 1,im-1          
        IF (fsm(i,j).NE.0.) THEN
           numcp2=numcp2+1
           indc2(1,numcp2)=i
           indc2(2,numcp2)=j           
        END IF
     END DO
  END DO


  WRITE(*,*) '____________________________________________________'
  WRITE(*,*) 'Condition.f90:  Horisontal points totally IM*JM:',im*jm
  WRITE(*,*) 'Number of ETA points:',numcp
  WRITE(*,*) 'Number of U points:',  numup
  WRITE(*,*) 'Number of V points:',  numvp    


END SUBROUTINE condition
