SUBROUTINE NRG3D(EKIN,VOLUME,MASS,EETA)
  USE STATE
  IMPLICIT NONE
  REAL EKIN,VOLUME,MASS,EETA
  INTEGER I,J,K
!
!Compute Volume, Potental energy 
!
  VOLUME=0.
  EKIN=0.
  MASS = 0.
  EETA = 0.
  
!$OMP PARALLEL DO REDUCTION(+:VOLUME) REDUCTION(+:EETA)  
  DO J = 1,JM
      DO I = 1,IM
          IF (FSM(I,J).GT.0.) THEN
              VOLUME = VOLUME + D(I,J)
              EETA = EETA + ETA(I,J)*ETA(I,J)
          END IF
      END DO
  END DO

!$OMP PARALLEL DO REDUCTION(+:MASS) REDUCTION(+:EKIN)    
  DO K = 1,KB-1
      DO J = 2,JM
          DO I = 2,IM
              IF (FSM(I,J).GT.0.) THEN  
                  MASS = MASS + (RHO(I,J,K)+RHOAVER+1000.)*D(I,J)*DZ(K)
              ENDIF
              IF (DUM(I,J).GT.0.) THEN
                  EKIN = EKIN + 0.5*(RHO(I,J,K)+RHO(I-1,J,K)+2*RHOAVER+2000.)* &
                       &            DZ(K)*DU(I,J)*U(I,J,K)*U(I,J,K)
              ENDIF
              IF (DVM(I,J).GT.0.) THEN
                  EKIN = EKIN + 0.5*(RHO(I,J,K)+RHO(I,J-1,K)+2*RHOAVER+2000.)*  &
                       &            DZ(K)*DV(I,J)*V(I,J,K)*V(I,J,K)
              ENDIF
          END DO
      END DO
  END DO

  VOLUME = VOLUME*DX*DY
  EKIN = EKIN*0.5*DX*DY/VOLUME
  MASS = DX*DY*MASS/VOLUME
  EETA = EETA*0.5*GRAV*1025.*DX*DY/VOLUME
!
  RETURN
END SUBROUTINE NRG3D
