SUBROUTINE TIDEINIT
!
!  TIDEINIT initializes the tidal forcing fields FREQ, ETATAMP, ETATPHA,
!  UATAMP, UATPHA, VATAMP and VATPHA to be used at the open bounaries to force in the
!  tidal components.
!
USE MOD_BOUND
IMPLICIT NONE
!
REAL PI
INTEGER K
INTEGER I,J
!
PI = 4.*ATAN(1.0)
!
!  Define the frequencies in radians per second.
!
FREQ(1) = 28.984*PI/(180.*3600.)  !  M2
FREQ(2) = 30.000*PI/(180.*3600.)  !  S2
FREQ(3) = 28.440*PI/(180.*3600.)  !  N2
FREQ(4) = 15.041*PI/(180.*3600.)  !  K1
!
!  Define the phases and amplitudes of the tidal fields.
!
ETATAMP(1:IM,1:JM,1) = 0.452  ! From tidal tabels from Norway
ETATAMP(1:IM,1:JM,2) = 0.163 
ETATAMP(1:IM,1:JM,3) = 0.089
ETATAMP(1:IM,1:JM,4) = 0.034
!
ETATPHA(1:IM,1:JM,1) = 288.2*PI/180.
ETATPHA(1:IM,1:JM,2) = 327.1*PI/180.
ETATPHA(1:IM,1:JM,3) = 267.8*PI/180.
ETATPHA(1:IM,1:JM,4) = 160.1*PI/180.
!
UATAMP = 0.
VATAMP = 0.
UATPHA = 0.
VATPHA = 0.
!
!
RETURN
END


